OPT OSVERSION=39

MODULE	'exec/nodes','exec/ports','exec/types','exec/memory',
				'intuition/intuition',
				'dos/dos','dos/dosextens','workbench/workbench',
				'workbench/startup','wb','icon','Asl','libraries/Asl'

	DEF appport=NIL:PTR TO mp
	DEF appflag=NIL
	DEF appicon,newproj[250]:STRING
	DEF lockname[250]:STRING,newlock=NIL
	DEF fname[250]:STRING
	DEF appobj:PTR TO diskobject
	DEF oldchoice
	DEF sleepobject=NIL:PTR TO diskobject
	DEF appobject:PTR TO diskobject
	DEF filename[250]:STRING
	DEF amsg:PTR TO appmessage
	DEF argptr:PTR TO wbarg
	DEF args:PTR TO wbarg
	DEF scratch
	DEF appname[250]:STRING
	DEF wb:PTR TO wbstartup
	DEF olddir
	DEF toolobject:PTR TO diskobject

PROC main()
	IF (workbenchbase:=OpenLibrary('workbench.library',0))
		IF (iconbase:=OpenLibrary('icon.library',0))
			IF (aslbase:=OpenLibrary('asl.library',0))

				IF wbmessage<>NIL
					wb:=wbmessage;args:=wb.arglist
					olddir:=CurrentDir(args.lock)
					IF args.name>0
						GetCurrentDirName(appname,250)
					ENDIF
				ENDIF
				StrAdd(appname,'Query_DropImage',ALL)

				IF (sleepobject:=GetDiskObjectNew(appname))=NIL
					sleepobject:=GetDefDiskObject(WBTOOL)
				ENDIF
				IF sleepobject
					sleepobject.type:=NIL
					appobject:=sleepobject
					IF (appport:=CreateMsgPort())
						IF (appicon:=AddAppIconA(0,0,'Query version',appport,0,appobject,NIL))<>NIL
							WHILE appflag=NIL
								WaitPort(appport)
								WHILE (amsg:=GetMsg(appport))<>NIL
									IF amsg.numargs=0
										IF EasyRequestArgs(0, [20, 0, 'Query version', 'COPYRIGHT 1994 by Chad Randall\n\nDo you wish to quit?','Ok|Cancel'], 0, 0)
											appflag:=TRUE
										ENDIF
									ELSE
										argptr:=amsg.arglist
										FOR scratch:=1 TO amsg.numargs
											StrCopy(newproj,argptr.name,ALL)
											newlock:=argptr.lock
											IF newlock
												NameFromLock(newlock,lockname,250)
												processname(filename,lockname,newproj)
												toggleiconplanes(filename)
											ENDIF
											argptr:=argptr+(SIZEOF wbarg)
										ENDFOR
									ENDIF
									ReplyMsg(amsg)
								ENDWHILE
							ENDWHILE
							RemoveAppIcon(appicon)
							WHILE (amsg:=GetMsg(appport))<>NIL
								ReplyMsg(amsg)
							ENDWHILE
						ENDIF
						DeleteMsgPort(appport)
					ENDIF
					FreeDiskObject(sleepobject);sleepobject:=NIL
				ENDIF
				CloseLibrary(aslbase)
			ENDIF
			CloseLibrary(iconbase)
		ENDIF
		CloseLibrary(workbenchbase)
	ENDIF
ENDPROC

PROC stripinfo(name)
	DEF comp1[6]:STRING,comp2[6]:STRING

	StrCopy(comp1,'.INFO',ALL)
	MidStr(comp2,name,StrLen(name)-5,5)
	UpperStr(comp2)
	IF StrCmp(comp1,comp2,5)
		MidStr(name,name,0,(StrLen(name)-5))
	ENDIF
ENDPROC

PROC processname(name,dir,file)

	DEF wish[20]:STRING

	StrCopy(name,dir,ALL)
	IF StrLen(file)            /* IF a file (NOT DISK/DRAWER) */
		RightStr(wish,name,1)
		IF StrCmp(wish,':',1)=NIL       /*  DISK:DIR/NAME */
			StrAdd(name,'/',ALL)
		ENDIF
		StrAdd(name,file,ALL)
	ELSE
		RightStr(wish,name,1)
		IF StrCmp(wish,':',1)        /* DISK:  (so add disk) */
			StrAdd(name,'disk',ALL)
		ENDIF
		IF StrCmp(wish,'/',1)        /* DISK:DIR/DIR/  (delete '/' */
			MidStr(name,name,0,StrLen(name)-1)
		ENDIF
	ENDIF
	MidStr(wish,name,0,1)
	IF StrCmp(wish,'/',1)
		MidStr(name,name,1,ALL)
	ENDIF	
	stripinfo(name)
ENDPROC

PROC toggleiconplanes(name)
	DEF diskobj:PTR TO diskobject
	DEF icongad:PTR TO gadget
	DEF regimage:PTR TO image,selimage:PTR TO image
	DEF sizetmp,sizetmp2,tmpbuf,tmpbuf2,oldtmp,oldtmp2
	DEF bufptr,bufptr2,dummy,scratch
	DEF body[1000]:STRING
	IF (diskobj:=GetDiskObject(name))
		IF (diskobj.pad_byte=$F0)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nUNREGISTERED Iconian 1.97',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$F1)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nRegistered Iconian 1.97',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$F2)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nUNREGISTERED Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$F3)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nRegistered Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E1)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nRegistered Amiga Dream Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E0)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nAmiga Dream Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E3)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nRegistered AUI Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E2)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nAUI Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E5)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nRegistered Disk of the Month-Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
		IF (diskobj.pad_byte=$E4)
			StringF(body,'"\s"',name)
			StrAdd(body,'\n\n    was saved using:\n\nDisk of the Month-Iconian 1.98',ALL)
			EasyRequestArgs(0, [20, 0, 'Query icon version', body,'Ok'], 0, 0)
		ENDIF
	ENDIF
ENDPROC
